#define __cplusplus__
#ifndef __FUNC__
#define __FUNC__

#include <cmath>
#include <iostream>
#include "known_functions.hpp"



class Function
{
private:
  int _dim;
  double (*_f)(double *x,int d);
  double _xmin;
  double _xmax;

public:

  Function();
  Function(int dim,   double (*f)(double *x,int d), double xmin, double xmax);
  // static Function rastrigin();
  ~Function();
  double Eval(double *x);
  // double Diff(double *x, double *y);
  double operator () (double *x);
  double getXmin();
  double getXmax();
  int get_dim();
};

//*****************************************************************
Function::Function(){
  // default : rastrigin + dim 3
  _dim=3;
  _f=f_9;
  _xmin=-5.12;
  _xmax=+5.12;
}

//*****************************************************************

Function::Function(int dim,   double (*f)(double *x,int d), double xmin, double xmax){
  _dim=dim;
  _f=f;
  _xmin=xmin;
  _xmax=xmax;
}

//*****************************************************************
Function::~Function(){

}
//*****************************************************************
double Function::Eval(double *x){
  return(_f(x,_dim));
}
//*****************************************************************

double Function::operator () (double *x){
  return(_f(x,_dim));
}

//*****************************************************************
double Function::getXmin (){
  return(_xmin);
}
//*****************************************************************
double Function::getXmax (){
  return(_xmax);
}

//*****************************************************************
int Function::get_dim (){
  return(_dim);
}


#endif






