#define __cplusplus__
#ifndef __FONC__
#define __FONC__

#include <cmath>
#include <iostream>

class Fonction
{
private:
  int _dim;
  double _f(double *x);
  double _df(double *x, double *y);


public:

  Fonction();
  Fonction(int dim, double *f);
  // static Fonction rastrigin();
  ~Fonction();
  double Eval(double *x);
  double Diff(double *x, double *y);

}

//*****************************************************************
Fonction::Fonction(){
  dim=0.0;  
}


//*****************************************************************

Fonction::Fonction(int dim,double *f){
  _dim=dim;
  _f=f;
}

//*****************************************************************
Fonction::~Fonction(){

}
//*****************************************************************
double Fonction::Eval(double *x){
  return(_f(x));
}

//*****************************************************************
double Fonction::Diff(double *x, double *y){
  return(_f(x)-_f(y));
}


//*****************************************************************
double Fonction::_f(double *x)
{
double E;

 E = 0.0 ;
 for (int i = 0; i < _dim ; i++)
     E += x[i]*x[i]  - 10.0 * cos(2.0 * 3.14159 * x[i]) + 10.0 ;
	
 return E;
}

//*****************************************************************

double Fonction::_df(double *x, double *y){
  return(_f(x)-_f(y));
}





#endif






