#include <cmath>
#include <cstdlib>
#include <ctime>

#define deux_pi (2.0*M_PI)


//**************************************************************

double *valeurs;

int intcompare(const void *i, const void *j) {

  int i1=*(int *)i;
  int j1=*(int *)j;
  if (valeurs[i1] < valeurs[j1])
    return (-1);
  if (valeurs[i1] > valeurs[j1])
    return (1);
  return (0);
}


void trier(int *permut, double *val,int n){
  valeurs=new double[n];
  for(int j=0;j<n;j++) valeurs[j]=val[j];
  qsort(permut,n,sizeof(int),intcompare);
  delete [] valeurs;
}

//**************************************************************************

double d_alea(){

  return(drand48());
}


//*************************************************************************

int i_alea(int d){
  return(rand() % d);
}

//***************************************************************

int binom(int n, double p){

  int k=0;
  for(int i=0;i<n;i++) if(d_alea()<p) k++;
  return(k);  
}

//**************************************************************


double f_1(double *x, int d){
  double E;
  
  E = 0.0 ;
  for (int j = 0; j < d ; j++)
     E += x[j]*x[j] ;
  // evaluations++;
        
 return E;
}


double f_2(double *x, int d){
  double E1,E2;
  
  E1 = 0.0 ; E2=0.0;
  for (int j = 0; j < d ; j++) {
    E1 = E1+ fabs(x[j]);
    E2 =E2*fabs(x[j]) ;
  // evaluations++;
  } 
 return(E1+E2);
}


double f_3(double *x, int d){
  double E,S;
  
  E = 0.0 ;S=0.0;
  for (int j = 0; j < d ; j++) {
    S+=x[j];    
     E += S*S ;
  // evaluations++;
  }
 return E;
}


double f_4(double *x, int d){
  double E;
  
  E = fabs(x[0]) ;
  for (int j = 0; j < d ; j++)
     if(E > fabs(x[j] )) E=fabs(x[j]);
  // evaluations++;
        
 return E;
}


double f_5(double *x, int d){
  double E;
  
  E = 0.0 ;
  for (int j = 0; j < (d-1) ; j++)
     E += 100.0*(x[j+1]-x[j]*x[j])*(x[j+1]-x[j]*x[j])  +(x[j] - 1)*(x[j] - 1) ;
  // evaluations++;
        
 return E/100.0;
}


double f_6(double *x, int d){
  double E;
  
  E = 0.0 ;
  for (int j = 0; j < d ; j++)
     E += floor(x[j] + 0.5)*  floor(x[j] + 0.5);
  // evaluations++;
        
 return E;
}


double f_7(double *x, int d){
  double E;
  
  E = 0.0 ;
  for (int j = 0; j < d ; j++)
     E += j*x[j]*x[j]*x[j]*x[j]  + d_alea();
  // evaluations++;        
 return E;
}


double f_8(double *x, int d){
  double E;
  
  E = 0.0;
  for (int j = 0; j < d ; j++)
     E += -x[j]*sin(sqrt(fabs(x[j]))) ;
  // evaluations++;
        
 return E;
}


double f_9(double *x, int d){
  double E;
  
  E = 0.0 ;
  for (int j = 0; j < d ; j++)
     E += x[j]*x[j]  - 10.0 * cos(deux_pi * x[j]) + 10.0 ;
  // evaluations++;
        
 return E;
}


double f_10(double *x, int d){
  double E1,E2;
  
  E1 = 0.0 ; E2 = 0.0 ;
  for (int j = 0; j < d ; j++)
    {
      E1 += x[j]*x[j] ;
      E2 += cos(deux_pi*x[j]) ;
    }      
  double E=-20*exp(-0.2*sqrt(E1/d)) - exp(E2/d) + 20 + exp(1);
  // evaluations++;
        
 return E;
}


double f_11(double *x, int d){
  double E1,E2;
  
  E1 = 0.0 ; E2 = 0.0 ;
  for (int j = 0; j < d ; j++)
    {
      E1 += x[j]*x[j] ;
      E2 *= cos(x[j]/sqrt(j)) ;
    }      
  double E=E1/4000.0 - E2 + 1;
  // evaluations++;
        
 return E;


}

double u(double x, double a, int k, int m){
  double E=0;
  if(x>a) E=k*pow(x-a,m);
  if(x<-a) E=k*pow(-x-a,m);
  return(E);
}

double f_12(double *x, int d){
  double E1,E2;
  double *y=new double[d];
  for (int j = 0; j < d ; j++)     y[j]=1.0 + 0.25*(x[j]+1);
  
  E1 = 0.0 ;  E2 = 0.0 ;

  for (int j = 0; j < (d-1) ; j++) {
    E1=(y[j]-1.0)*(y[j]-1.0)*(1.0+10.0*sin(M_PI*y[j+1])*sin(M_PI*y[j+1]));
    E2=u(x[j],10,100,4);
  }
   double  E = M_PI*(10.0*sin(M_PI*y[0])*sin(M_PI*y[0]) + E1 + (y[d] -1.0)*(y[d] -1.0))/d + E2 ;
  // evaluations++;
   delete [] y;
   return E;
}


double f_13(double *x, int d){

  double E1,E2;
  
  E1 = 0.0 ;  E2 = 0.0 ;

  for (int j = 0; j < (d-1) ; j++) {
    E1=(x[j]-1.0)*(x[j]-1.0)*(1.0+sin(3.0*M_PI*x[j+1])*sin(3.0*M_PI*x[j+1]));
    E2=u(x[j],5,100,4);
  }
   double  E = 0.1*(sin(3.0*M_PI*x[1])*sin(3.0*M_PI*x[1])+E1 + (x[d] -1.0)*(x[d] -1.0)*(1.0+ sin(deux_pi*x[d])*sin(deux_pi*x[d]))) + E2 ;
  // evaluations++;
        
 return E;
}


